> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# Create POS Sale

POST https://api.npretail.app/{tenant}/{environment}/{company}/pos/sale/{saleId}
Content-Type: application/json

Creates a new POS sale with the provided GUID. The API consumer must provide their own unique GUID which will be used as the SystemId. The POS Unit is resolved from the API user's User Setup and must be of type UNATTENDED to support multiple concurrent active sales per unit.

Reference: https://docs.navipartner.com/apis/api-reference/pos/possale/create-pos-sale

## Authentication

- `x-np-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `tenant` (string, required) — Your Entra Tenant ID. [More details.](/paths#1-tenant)
- `environment` (string, required) — Your Business Central Environment. [More details.](/paths#2-environment)
- `company` (string, required) — Your Business Central Company. [More details.](/paths#3-company)
- `saleId` (UUID, required) — The id of a POS sale. This can be provided by the API consumer when creating a new sale.

### Body (application/json)

This endpoint expects a CreatePOSSale.

- `customerNo` (string, optional) — The customer number to assign to this sale
- `vatBusinessPostingGroup` (string, optional) — The VAT Business Posting Group to use for this sale
- `genBusinessPostingGroup` (string, optional) — The Gen. Business Posting Group to use for this sale

## Response

### 201

- `saleId` (UUID, required) — The id of a POS sale. This can be provided by the API consumer when creating a new sale.
- `receiptNo` (string, required)
- `posUnit` (string, required)
- `posStore` (string, required)
- `date` (date, required)
- `startTime` (datetime, required)
- `customerNo` (string, required)
- `salespersonCode` (string, required)
- `vatBusinessPostingGroup` (string, required)
- `genBusinessPostingGroup` (string, required)
- `saleLines` (list of POSSaleLineResponse, optional)
- `paymentLines` (list of POSPaymentLineResponse, optional)
- `totalSalesAmountInclVat` (double, optional) — Total amount of all sale lines including VAT (only present when withLines=true)
- `totalPaymentAmount` (double, optional) — Total amount of all payment lines (only present when withLines=true)

## Types

### POSSaleLineResponse

A sale line in the response

- `id` (UUID, required) — The id of a sale line within a POS sale.
- `sortKey` (integer, required)
- `type` (enum, required)
  - Allowed values: `Item`, `Item Category`, `BOM List`, `Customer Deposit`, `Comment`, `Rounding`, `G/L Payment`, `Issue Voucher`
- `code` (string, required)
- `variantCode` (string, required)
- `description` (string, required)
- `quantity` (double, required)
- `unitPrice` (double, required)
- `discountPct` (double, required)
- `discountAmount` (double, required)
- `vatPercent` (double, required)
- `amountInclVat` (double, required)
- `amount` (double, required)
- `unitOfMeasure` (string, required)
- `isAddon` (boolean, required) — Whether this line is an addon to another item
- `description2` (string, optional)
- `appliesToLine` (UUID, optional) — If this is an addon, the SystemId of the parent line it applies to
- `deleted` (boolean, optional)

### POSPaymentLineResponse

A payment line in the response

- `id` (UUID, required) — The id of a payment line within a POS sale.
- `sortKey` (integer, required)
- `paymentMethodCode` (string, required)
- `description` (string, required)
- `amountInclVat` (double, required)
- `deleted` (boolean, optional)

## Examples

**Request**

```json
{
  "customerNo": "C12345"
}
```

**Response**

```json
{
  "saleId": "0d200aa6-aacd-4b78-b673-c4fb7461f5ea",
  "receiptNo": "12345678",
  "posUnit": "QR_FOOD_APP",
  "posStore": "STORE01",
  "date": "2024-01-01",
  "startTime": "2024-01-01T17:00:00Z",
  "customerNo": "C12345",
  "salespersonCode": "SP001",
  "vatBusinessPostingGroup": "DOMESTIC",
  "genBusinessPostingGroup": "DOMESTIC"
}
```

**SDK Code**

```python
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./pos/sale/0d200aa6-aacd-4b78-b673-c4fb7461f5ea"

payload = { "customerNo": "C12345" }
headers = {
    "x-np-api-key": "<NaviPartner API Key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./pos/sale/0d200aa6-aacd-4b78-b673-c4fb7461f5ea';
const options = {
  method: 'POST',
  headers: {'x-np-api-key': '<NaviPartner API Key>', 'Content-Type': 'application/json'},
  body: '{"customerNo":"C12345"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./pos/sale/0d200aa6-aacd-4b78-b673-c4fb7461f5ea"

	payload := strings.NewReader("{\n  \"customerNo\": \"C12345\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./pos/sale/0d200aa6-aacd-4b78-b673-c4fb7461f5ea")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"customerNo\": \"C12345\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./pos/sale/0d200aa6-aacd-4b78-b673-c4fb7461f5ea")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"customerNo\": \"C12345\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./pos/sale/0d200aa6-aacd-4b78-b673-c4fb7461f5ea', [
  'body' => '{
  "customerNo": "C12345"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./pos/sale/0d200aa6-aacd-4b78-b673-c4fb7461f5ea");
var request = new RestRequest(Method.POST);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"customerNo\": \"C12345\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "x-np-api-key": "<NaviPartner API Key>",
  "Content-Type": "application/json"
]
let parameters = ["customerNo": "C12345"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./pos/sale/0d200aa6-aacd-4b78-b673-c4fb7461f5ea")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```